#include <iostream>

#include "TRandom.h"
#include "TTree.h"
#include "TFile.h"

#include "A.h"

//-----------------------------------------------------------------
void create(A &a)
{
	size_t nB = gRandom->Uniform(1,10);

	for (size_t iB=0; iB < nB; ++iB)
		a.AddB().SetDummy(gRandom->Gaus(0,5));
}

//-----------------------------------------------------------------
void draw(const A &a)
{
	std::cout << "A contains "<< a.GetNbrB()<<" B's"<<std::endl;
	for (size_t iB=0;iB < a.GetNbrB(); ++iB)
		std::cout << " B("<<iB+1<<") has dummy "<< a.GetB(iB).GetDummy()<<std::endl;
}

//-----------------------------------------------------------------
void WriteRootFile()
{
	TFile o("Test.root","RECREATE");
	TTree t("tree","test");

	A *a = new A();
	
	t.Branch("a","A",&a);

	size_t nA=2;

	std::cout <<"Creating "<<nA<<" A's"<<std::endl;
	for (size_t iA=0; iA<nA; ++iA)
	{
		a->Clear();
		//create(*a);	//undo this comment and the program won't crash
		draw(*a);
		t.Fill();
	}
	o.Write();

	delete a;
}

//-----------------------------------------------------------------
void ReadRootFile() 
{
	TFile *f = new TFile("Test.root");
	TTree *t = reinterpret_cast<TTree*> (f->Get("tree"));

	A *a = 0;
	t->SetBranchAddress("a", &a);
	size_t nA = static_cast<size_t>(t->GetEntries());
	
	std::cout <<"The tree has "<<nA<<" A's"<<std::endl;
	for (size_t i=0; i<nA; i++) 
	{
		cout << "reading "<< i+1<<endl;
		t->GetEntry(i);
		draw(*a);
	}
	delete t;
	delete f;
}

//-----------------------------------------------------------------
int main(int argc, char *argv[])
{
	std::cout<<std::endl<<std::endl<< "write root file"<<std::endl;
	WriteRootFile();
	std::cout<<std::endl<<std::endl<< "reading root file"<<std::endl;
	ReadRootFile();

	return 0;
}